diff -Nura php-5.0.4/Zend/zend_execute.c hardening-patch-5.0.4-0.4.1/Zend/zend_execute.c
--- php-5.0.4/Zend/zend_execute.c	2005-03-21 17:22:10.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_execute.c	2005-08-06 09:47:01.000000000 +0200
@@ -1343,6 +1343,7 @@
  		efree(EX(Ts));							\
  	}									\
 	EG(in_execution) = EX(original_in_execution);							\
+	EG(in_code_type) = EX(original_in_code_type);								\
 	EG(current_execute_data) = EX(prev_execute_data);						\
 	return 1; /* CHECK_ME */
 
@@ -1369,6 +1370,16 @@
 	EX(original_in_execution) = EG(in_execution);
 	EX(prev_execute_data) = EG(current_execute_data);
 	EG(current_execute_data) = &execute_data;
+#if HARDENING_PATCH	
+	EX(execute_depth) = 0;
+
+	if ((op_array->type == ZEND_EVAL_CODE || op_array->created_by_eval)&& EG(in_code_type) != ZEND_SANDBOX_CODE) {
+		EG(in_code_type) = ZEND_EVAL_CODE;
+	} else if (op_array->type == ZEND_SANDBOX_CODE) {
+		EG(in_code_type) = ZEND_SANDBOX_CODE;
+		op_array->type = ZEND_EVAL_CODE;
+	}
+#endif
 
 	EG(in_execution) = 1;
 	if (op_array->start_op) {
@@ -1395,6 +1406,19 @@
 	EX(function_state).function_symbol_table = NULL;
 #endif
 	
+#if HARDENING_PATCH	
+	if (EX(prev_execute_data) == NULL) {
+		EX(execute_depth) = 0;
+	} else {
+		EX(execute_depth) = EX(prev_execute_data)->execute_depth + 1;
+	}
+
+	if (EG(hphp_executor_max_depth) > 0 && EX(execute_depth) > EG(hphp_executor_max_depth)) {
+		zend_security_log(S_EXECUTOR, "Maximum execution depth of %u violated", EG(hphp_executor_max_depth));
+		zend_bailout();
+	}
+#endif
+
 	while (1) {
 #ifdef ZEND_WIN32
 		if (EG(timed_out)) {
@@ -2647,6 +2671,37 @@
 		efree(lcname);
 		zend_error(E_ERROR, "Call to undefined function %s()", function_name_strval);
 	}
+#if HARDENING_PATCH	
+	if (EG(in_code_type) == ZEND_EVAL_CODE) {
+		if (HG(eval_whitelist) != NULL) {
+			if (!zend_hash_exists(HG(eval_whitelist), lcname, function_name_strlen+1)) {
+			    zend_security_log(S_EXECUTOR, "function outside of eval whitelist called: %s()", lcname);
+			    efree(lcname);
+			    zend_bailout();
+			}
+		} else if (HG(eval_blacklist) != NULL) {
+			if (zend_hash_exists(HG(eval_blacklist), lcname, function_name_strlen+1)) {
+			    zend_security_log(S_EXECUTOR, "function within eval blacklist called: %s()", lcname);
+			    efree(lcname);
+			    zend_bailout();
+			}
+		}
+	}
+	
+	if (HG(func_whitelist) != NULL) {
+		if (!zend_hash_exists(HG(func_whitelist), lcname, function_name_strlen+1)) {
+		    zend_security_log(S_EXECUTOR, "function outside of whitelist called: %s()", lcname);
+		    efree(lcname);
+		    zend_bailout();
+		}
+	} else if (HG(func_blacklist) != NULL) {
+		if (zend_hash_exists(HG(func_blacklist), lcname, function_name_strlen+1)) {
+		    zend_security_log(S_EXECUTOR, "function within blacklist called: %s()", lcname);
+		    efree(lcname);
+		    zend_bailout();
+		}
+	}
+#endif
 
 	efree(lcname);
 	if (!is_const) {
@@ -2851,6 +2906,34 @@
 	if (zend_hash_find(EG(function_table), fname->value.str.val, fname->value.str.len+1, (void **) &EX(function_state).function)==FAILURE) {
 		zend_error(E_ERROR, "Unknown function:  %s()\n", fname->value.str.val);
 	}
+#if HARDENING_PATCH	
+	if (EG(in_code_type) == ZEND_EVAL_CODE) {
+		if (HG(eval_whitelist) != NULL) {
+			if (!zend_hash_exists(HG(eval_whitelist), fname->value.str.val, fname->value.str.len+1)) {
+			    zend_security_log(S_EXECUTOR, "function outside of eval whitelist called: %s()", fname->value.str.val);
+			    zend_bailout();
+			}
+		} else if (HG(eval_blacklist) != NULL) {
+			if (zend_hash_exists(HG(eval_blacklist), fname->value.str.val, fname->value.str.len+1)) {
+			    zend_security_log(S_EXECUTOR, "function within eval blacklist called: %s()", fname->value.str.val);
+			    zend_bailout();
+			}
+		}
+	}
+
+	if (HG(func_whitelist) != NULL) {
+		if (!zend_hash_exists(HG(func_whitelist), fname->value.str.val, fname->value.str.len+1)) {
+		    zend_security_log(S_EXECUTOR, "function outside of whitelist called: %s()", fname->value.str.val);
+		    zend_bailout();
+		}
+	} else if (HG(func_blacklist) != NULL) {
+		if (zend_hash_exists(HG(func_blacklist), fname->value.str.val, fname->value.str.len+1)) {
+		    zend_security_log(S_EXECUTOR, "function within blacklist called: %s()", fname->value.str.val);
+		    zend_bailout();
+		}
+	}
+#endif
+	
 	EX(object) = NULL;
 	EX(calling_scope) = EX(function_state).function->common.scope;
 
@@ -3523,7 +3606,12 @@
 				int dummy = 1;
 				zend_file_handle file_handle;
 
+#if HARDENING_PATCH_INC_PROTECT
+				if (zend_is_valid_include(inc_filename) 
+					&& (SUCCESS == zend_stream_open(inc_filename->value.str.val, &file_handle TSRMLS_CC))) {
+#else
 				if (SUCCESS == zend_stream_open(inc_filename->value.str.val, &file_handle TSRMLS_CC)) {
+#endif
 
 					if (!file_handle.opened_path) {
 						file_handle.opened_path = estrndup(inc_filename->value.str.val, inc_filename->value.str.len);
@@ -3548,6 +3636,11 @@
 			break;
 		case ZEND_INCLUDE:
 		case ZEND_REQUIRE:
+#if HARDENING_PATCH_INC_PROTECT
+			if (!zend_is_valid_include(inc_filename)) {
+				break;
+			}
+#endif
 			new_op_array = compile_filename(opline->op2.u.constant.value.lval, inc_filename TSRMLS_CC);
 			break;
 		case ZEND_EVAL: {
diff -Nura php-5.0.4/Zend/zend_extensions.c hardening-patch-5.0.4-0.4.1/Zend/zend_extensions.c
--- php-5.0.4/Zend/zend_extensions.c	2004-01-08 18:31:47.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_extensions.c	2005-08-04 13:02:02.000000000 +0200
@@ -55,23 +55,44 @@
 		return FAILURE;
 	}
 
+	/* check if module is compiled against Hardening-Patch */
+	if (extension_version_info->zend_extension_api_no < 1000000000) {
+		fprintf(stderr, "%s is not compiled with Hardening-Patch.\n"
+				"The Hardening-Patch version %d is installed.\n\n",
+				new_extension->name,
+				HARDENING_PATCH_ZEND_EXTENSION_API_NO);
+		DL_UNLOAD(handle);
+		return FAILURE;
+	}
+
+
+	/* check if module is compiled against correct Hardening-Patch version */
+	if (extension_version_info->zend_extension_api_no != HARDENING_PATCH_ZEND_EXTENSION_API_NO) {
+		fprintf(stderr, "%s requires Hardening-Patch version %d.\n"
+				"The Hardening-Patch version %d is installed.\n\n",
+				new_extension->name,
+				extension_version_info->zend_extension_api_no,
+				HARDENING_PATCH_ZEND_EXTENSION_API_NO);
+		DL_UNLOAD(handle);
+		return FAILURE;
+	}
 
 	/* allow extension to proclaim compatibility with any Zend version */
-	if (extension_version_info->zend_extension_api_no != ZEND_EXTENSION_API_NO &&(!new_extension->api_no_check || new_extension->api_no_check(ZEND_EXTENSION_API_NO) != SUCCESS)) {
-		if (extension_version_info->zend_extension_api_no > ZEND_EXTENSION_API_NO) {
+	if (extension_version_info->real_zend_extension_api_no != ZEND_EXTENSION_API_NO &&(!new_extension->api_no_check || new_extension->api_no_check(ZEND_EXTENSION_API_NO) != SUCCESS)) {
+		if (extension_version_info->real_zend_extension_api_no > ZEND_EXTENSION_API_NO) {
 			fprintf(stderr, "%s requires Zend Engine API version %d.\n"
 					"The Zend Engine API version %d which is installed, is outdated.\n\n",
 					new_extension->name,
-					extension_version_info->zend_extension_api_no,
+					extension_version_info->real_zend_extension_api_no,
 					ZEND_EXTENSION_API_NO);
 			DL_UNLOAD(handle);
 			return FAILURE;
-		} else if (extension_version_info->zend_extension_api_no < ZEND_EXTENSION_API_NO) {
+		} else if (extension_version_info->real_zend_extension_api_no < ZEND_EXTENSION_API_NO) {
 			fprintf(stderr, "%s requires Zend Engine API version %d.\n"
 					"The Zend Engine API version %d which is installed, is newer.\n"
 					"Contact %s at %s for a later version of %s.\n\n",
 					new_extension->name,
-					extension_version_info->zend_extension_api_no,
+					extension_version_info->real_zend_extension_api_no,
 					ZEND_EXTENSION_API_NO,
 					new_extension->author,
 					new_extension->URL,
diff -Nura php-5.0.4/Zend/zend_extensions.h hardening-patch-5.0.4-0.4.1/Zend/zend_extensions.h
--- php-5.0.4/Zend/zend_extensions.h	2004-11-25 21:26:48.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_extensions.h	2005-08-06 18:16:17.328900512 +0200
@@ -24,9 +24,11 @@
 
 #include "zend_compile.h"
 
-/* The first number is the engine version and the rest is the date.
+/* The first API number is a flag saying that Hardening-Patch is used.
+ * The second number is the engine version and the date.
  * This way engine 2 API no. is always greater than engine 1 API no..
  */
+#define HARDENING_PATCH_ZEND_EXTENSION_API_NO	1002050805
 #define ZEND_EXTENSION_API_NO	220040412
 
 typedef struct _zend_extension_version_info {
@@ -34,6 +36,7 @@
 	char *required_zend_version;
 	unsigned char thread_safe;
 	unsigned char debug;
+	int real_zend_extension_api_no;
 } zend_extension_version_info;
 
 
@@ -101,7 +104,7 @@
 
 
 #define ZEND_EXTENSION()	\
-	ZEND_EXT_API zend_extension_version_info extension_version_info = { ZEND_EXTENSION_API_NO, ZEND_VERSION, ZTS_V, ZEND_DEBUG }
+	ZEND_EXT_API zend_extension_version_info extension_version_info = { HARDENING_PATCH_ZEND_EXTENSION_API_NO, ZEND_VERSION, ZTS_V, ZEND_DEBUG, ZEND_EXTENSION_API_NO }
 
 #define STANDARD_ZEND_EXTENSION_PROPERTIES NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, -1
 #define COMPAT_ZEND_EXTENSION_PROPERTIES   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, -1
diff -Nura php-5.0.4/Zend/zend_globals.h hardening-patch-5.0.4-0.4.1/Zend/zend_globals.h
--- php-5.0.4/Zend/zend_globals.h	2004-11-04 00:14:31.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_globals.h	2005-08-04 12:06:45.000000000 +0200
@@ -174,6 +174,16 @@
 
 	int error_reporting;
 	int orig_error_reporting;
+#if HARDENING_PATCH
+	int hphp_log_syslog;
+	int hphp_log_syslog_facility;
+	int hphp_log_syslog_priority;
+	int hphp_log_sapi;
+	int hphp_log_script;
+	char *hphp_log_scriptname;
+	zend_bool hphp_log_use_x_forwarded_for;
+	long hphp_executor_max_depth;
+#endif
 	int exit_status;
 
 	zend_op_array *active_op_array;
@@ -191,6 +201,7 @@
 	int ticks_count;
 
 	zend_bool in_execution;
+	zend_uint in_code_type;
 	HashTable *in_autoload;
 	zend_bool bailout_set;
 	zend_bool full_tables_cleanup;
diff -Nura php-5.0.4/Zend/zend.h hardening-patch-5.0.4-0.4.1/Zend/zend.h
--- php-5.0.4/Zend/zend.h	2005-03-10 12:30:44.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend.h	2005-08-04 12:06:45.000000000 +0200
@@ -290,6 +290,7 @@
 	/* Variable information */
 	zvalue_value value;		/* value */
 	zend_uint refcount;
+	zend_ushort flags;
 	zend_uchar type;	/* active type */
 	zend_uchar is_ref;
 };
@@ -359,6 +360,12 @@
 	void (*on_timeout)(int seconds TSRMLS_DC);
 	int (*stream_open_function)(const char *filename, zend_file_handle *handle TSRMLS_DC);
 	int (*vspprintf_function)(char **pbuf, size_t max_len, const char *format, va_list ap);
+#if HARDENING_PATCH
+	void (*security_log_function)(int loglevel, char *fmt, ...);
+#endif	
+#if HARDENING_PATCH_INC_PROTECT
+	int (*is_valid_include)(zval *z);
+#endif
 } zend_utility_functions;
 
 		
@@ -496,6 +503,16 @@
 extern void (*zend_on_timeout)(int seconds TSRMLS_DC);
 extern ZEND_API int (*zend_stream_open_function)(const char *filename, zend_file_handle *handle TSRMLS_DC);
 extern int (*zend_vspprintf)(char **pbuf, size_t max_len, const char *format, va_list ap);
+#if HARDENING_PATCH
+extern ZEND_API	void (*zend_security_log)(int loglevel, char *fmt, ...);
+#endif	
+#if HARDENING_PATCH_INC_PROTECT
+extern ZEND_API int (*zend_is_valid_include)(zval *z);
+#endif
+  
+#if HARDENING_PATCH_MM_PROTECT || HARDENING_PATCH_LL_PROTECT || HARDENING_PATCH_HASH_PROTECT
+ZEND_API unsigned int zend_canary(void);
+#endif
 
 
 ZEND_API void zend_error(int type, const char *format, ...) ZEND_ATTRIBUTE_FORMAT(printf, 2, 3);
@@ -620,6 +637,11 @@
 #define ZEND_MAX_RESERVED_RESOURCES	4
 
 
+#if HARDENING_PATCH
+#include "hardened_globals.h"
+#include "php_syslog.h"
+#endif
+
 #endif /* ZEND_H */
 
 /*
diff -Nura php-5.0.4/Zend/zend_hash.c hardening-patch-5.0.4-0.4.1/Zend/zend_hash.c
--- php-5.0.4/Zend/zend_hash.c	2004-07-10 09:45:49.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_hash.c	2005-08-04 12:06:45.000000000 +0200
@@ -21,6 +21,18 @@
 
 #include "zend.h"
 
+#if HARDENING_PATCH_HASH_PROTECT
+	unsigned int zend_hash_canary = 0x1234567;
+	zend_bool zend_hash_canary_inited = 0;
+#endif
+
+#define CHECK_HASH_CANARY(hash) \
+	if (zend_hash_canary != (hash)->canary) { \
+		zend_security_log(S_MEMORY, "Zend HashTable canary was overwritten"); \
+		exit(1); \
+	}
+
+
 #define CONNECT_TO_BUCKET_DLLIST(element, list_head)		\
 	(element)->pNext = (list_head);							\
 	(element)->pLast = NULL;								\
@@ -138,6 +150,9 @@
 {
 	uint i = 3;
 	Bucket **tmp;
+#if HARDENING_PATCH_HASH_PROTECT
+	TSRMLS_FETCH();	
+#endif	
 
 	SET_INCONSISTENT(HT_OK);
 
@@ -147,6 +162,13 @@
 
 	ht->nTableSize = 1 << i;
 	ht->nTableMask = ht->nTableSize - 1;
+#if HARDENING_PATCH_HASH_PROTECT
+	if (zend_hash_canary_inited==0) {
+		zend_hash_canary = zend_canary();
+		zend_hash_canary_inited = 1;
+	}
+	ht->canary = zend_hash_canary;
+#endif
 	ht->pDestructor = pDestructor;
 	ht->arBuckets = NULL;
 	ht->pListHead = NULL;
@@ -226,6 +248,9 @@
 				}
 #endif
 				if (ht->pDestructor) {
+#if HARDENING_PATCH_HASH_PROTECT
+					CHECK_HASH_CANARY(ht);
+#endif	
 					ht->pDestructor(p->pData);
 				}
 				UPDATE_DATA(ht, p, pData, nDataSize);
@@ -291,6 +316,9 @@
 				}
 #endif
 				if (ht->pDestructor) {
+#if HARDENING_PATCH_HASH_PROTECT
+					CHECK_HASH_CANARY(ht);
+#endif	
 					ht->pDestructor(p->pData);
 				}
 				UPDATE_DATA(ht, p, pData, nDataSize);
@@ -366,6 +394,9 @@
 			}
 #endif
 			if (ht->pDestructor) {
+#if HARDENING_PATCH_HASH_PROTECT
+				CHECK_HASH_CANARY(ht);
+#endif	
 				ht->pDestructor(p->pData);
 			}
 			UPDATE_DATA(ht, p, pData, nDataSize);
@@ -414,7 +445,7 @@
 	IS_CONSISTENT(ht);
 
 	if ((ht->nTableSize << 1) > 0) {	/* Let's double the table size */
-		t = (Bucket **) perealloc_recoverable(ht->arBuckets, (ht->nTableSize << 1) * sizeof(Bucket *), ht->persistent);
+		t = (Bucket **) perealloc(ht->arBuckets, (ht->nTableSize << 1) * sizeof(Bucket *), ht->persistent);
 		if (t) {
 			HANDLE_BLOCK_INTERRUPTIONS();
 			ht->arBuckets = t;
@@ -424,6 +455,7 @@
 			HANDLE_UNBLOCK_INTERRUPTIONS();
 			return SUCCESS;
 		}
+		zend_error(E_ERROR, "zend_hash_do_resize - out of memory");
 		return FAILURE;
 	}
 	return SUCCESS;
@@ -487,6 +519,9 @@
 				ht->pInternalPointer = p->pListNext;
 			}
 			if (ht->pDestructor) {
+#if HARDENING_PATCH_HASH_PROTECT
+				CHECK_HASH_CANARY(ht);
+#endif	
 				ht->pDestructor(p->pData);
 			}
 			if (!p->pDataPtr) {
@@ -516,6 +551,9 @@
 		q = p;
 		p = p->pListNext;
 		if (ht->pDestructor) {
+#if HARDENING_PATCH_HASH_PROTECT
+			CHECK_HASH_CANARY(ht);
+#endif	
 			ht->pDestructor(q->pData);
 		}
 		if (!q->pDataPtr && q->pData) {
@@ -542,6 +580,9 @@
 		q = p;
 		p = p->pListNext;
 		if (ht->pDestructor) {
+#if HARDENING_PATCH_HASH_PROTECT
+			CHECK_HASH_CANARY(ht);
+#endif	
 			ht->pDestructor(q->pData);
 		}
 		if (!q->pDataPtr && q->pData) {
@@ -571,6 +612,9 @@
 	HANDLE_BLOCK_INTERRUPTIONS();
 
 	if (ht->pDestructor) {
+#if HARDENING_PATCH_HASH_PROTECT
+		CHECK_HASH_CANARY(ht);
+#endif	
 		ht->pDestructor(p->pData);
 	}
 	if (!p->pDataPtr) {
diff -Nura php-5.0.4/Zend/zend_hash.h hardening-patch-5.0.4-0.4.1/Zend/zend_hash.h
--- php-5.0.4/Zend/zend_hash.h	2004-01-08 18:31:47.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_hash.h	2005-08-04 12:06:45.000000000 +0200
@@ -58,6 +58,9 @@
 } Bucket;
 
 typedef struct _hashtable {
+#if HARDENING_PATCH_HASH_PROTECT
+	unsigned int canary;
+#endif	
 	uint nTableSize;
 	uint nTableMask;
 	uint nNumOfElements;
diff -Nura php-5.0.4/Zend/zend_language_scanner.c hardening-patch-5.0.4-0.4.1/Zend/zend_language_scanner.c
--- php-5.0.4/Zend/zend_language_scanner.c	2005-04-03 11:42:53.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_language_scanner.c	2005-08-06 10:08:58.000000000 +0200
@@ -3152,6 +3152,13 @@
 		compilation_successful=0;
 	} else {
 		init_op_array(op_array, ZEND_USER_FUNCTION, INITIAL_OP_ARRAY_SIZE TSRMLS_CC);
+#if HARDENING_PATCH
+		if (EG(in_code_type)==ZEND_EVAL_CODE) {
+			op_array->created_by_eval = 1;
+		} else {
+			op_array->created_by_eval = 0;
+		}
+#endif
 		CG(in_compilation) = 1;
 		CG(active_op_array) = op_array;
 		compiler_result = zendparse(TSRMLS_C);
diff -Nura php-5.0.4/Zend/zend_language_scanner.l hardening-patch-5.0.4-0.4.1/Zend/zend_language_scanner.l
--- php-5.0.4/Zend/zend_language_scanner.l	2005-03-07 17:48:12.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_language_scanner.l	2005-08-06 10:08:40.000000000 +0200
@@ -385,6 +385,13 @@
 		compilation_successful=0;
 	} else {
 		init_op_array(op_array, ZEND_USER_FUNCTION, INITIAL_OP_ARRAY_SIZE TSRMLS_CC);
+#if HARDENING_PATCH
+		if (EG(in_code_type)==ZEND_EVAL_CODE) {
+			op_array->created_by_eval = 1;
+		} else {
+			op_array->created_by_eval = 0;
+		}
+#endif
 		CG(in_compilation) = 1;
 		CG(active_op_array) = op_array;
 		compiler_result = zendparse(TSRMLS_C);
diff -Nura php-5.0.4/Zend/zend_llist.c hardening-patch-5.0.4-0.4.1/Zend/zend_llist.c
--- php-5.0.4/Zend/zend_llist.c	2004-01-08 18:31:47.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_llist.c	2005-08-04 12:06:45.000000000 +0200
@@ -22,9 +22,34 @@
 #include "zend.h"
 #include "zend_llist.h"
 #include "zend_qsort.h"
+#include "zend_globals.h"
+
+#define CHECK_LIST_CANARY(list) \
+	if (HG(canary_3) != (list)->canary_h || HG(canary_4) != (list)->canary_t) { \
+		zend_security_log(S_MEMORY, "linked list canary was overwritten"); \
+		exit(1); \
+	}
+
+#define CHECK_LISTELEMENT_CANARY(elem) \
+	if (HG(canary_3) != (elem)->canary) { \
+		zend_security_log(S_MEMORY, "linked list element canary was overwritten"); \
+		exit(1); \
+	}
+
 
 ZEND_API void zend_llist_init(zend_llist *l, size_t size, llist_dtor_func_t dtor, unsigned char persistent)
 {
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();	
+	
+	if (!HG(ll_canary_inited)) {
+		HG(canary_3) = zend_canary();
+		HG(canary_4) = zend_canary();
+		HG(ll_canary_inited) = 1;
+	}
+	l->canary_h = HG(canary_3);
+	l->canary_t = HG(canary_4);
+#endif
 	l->head  = NULL;
 	l->tail  = NULL;
 	l->count = 0;
@@ -38,6 +63,11 @@
 {
 	zend_llist_element *tmp = pemalloc(sizeof(zend_llist_element)+l->size-1, l->persistent);
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();	
+	CHECK_LIST_CANARY(l)
+	tmp->canary = HG(canary_3);
+#endif
 	tmp->prev = l->tail;
 	tmp->next = NULL;
 	if (l->tail) {
@@ -56,6 +86,11 @@
 {
 	zend_llist_element *tmp = pemalloc(sizeof(zend_llist_element)+l->size-1, l->persistent);
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();	
+	CHECK_LIST_CANARY(l)
+	tmp->canary = HG(canary_3);
+#endif
 	tmp->next = l->head;
 	tmp->prev = NULL;
 	if (l->head) {
@@ -93,10 +128,20 @@
 	zend_llist_element *current=l->head;
 	zend_llist_element *next;
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();	
+	CHECK_LIST_CANARY(l)
+#endif
 	while (current) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(current)
+#endif
 		next = current->next;
 		if (compare(current->data, element)) {
 			DEL_LLIST_ELEMENT(current, l);
+#if HARDENING_PATCH_LL_PROTECT
+			current->canary = 0;
+#endif
 			break;
 		}
 		current = next;
@@ -108,7 +153,14 @@
 {
 	zend_llist_element *current=l->head, *next;
 	
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();	
+	CHECK_LIST_CANARY(l)
+#endif
 	while (current) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(current)
+#endif
 		next = current->next;
 		if (l->dtor) {
 			l->dtor(current->data);
@@ -133,7 +185,14 @@
 	zend_llist_element *old_tail;
 	void *data;
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();	
+	CHECK_LIST_CANARY(l)
+#endif
 	if ((old_tail = l->tail)) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(old_tail)
+#endif
 		if (l->tail->prev) {
 			l->tail->prev->next = NULL;
 		}
@@ -159,9 +218,16 @@
 {
 	zend_llist_element *ptr;
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();	
+	CHECK_LIST_CANARY(src)
+#endif
 	zend_llist_init(dst, src->size, src->dtor, src->persistent);
 	ptr = src->head;
 	while (ptr) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(ptr)
+#endif
 		zend_llist_add_element(dst, ptr->data);
 		ptr = ptr->next;
 	}
@@ -172,11 +238,21 @@
 {
 	zend_llist_element *element, *next;
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();	
+	CHECK_LIST_CANARY(l)
+#endif
 	element=l->head;
 	while (element) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(element)
+#endif
 		next = element->next;
 		if (func(element->data)) {
 			DEL_LLIST_ELEMENT(element, l);
+#if HARDENING_PATCH_LL_PROTECT
+			element->canary = 0;
+#endif
 		}
 		element = next;
 	}
@@ -187,7 +263,13 @@
 {
 	zend_llist_element *element;
 
+#if HARDENING_PATCH_LL_PROTECT
+	CHECK_LIST_CANARY(l)
+#endif
 	for (element=l->head; element; element=element->next) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(element)
+#endif
 		func(element->data TSRMLS_CC);
 	}
 }
@@ -199,6 +281,9 @@
 	zend_llist_element **elements;
 	zend_llist_element *element, **ptr;
 
+#if HARDENING_PATCH_LL_PROTECT
+	CHECK_LIST_CANARY(l)
+#endif
 	if (l->count <= 0) {
 		return;
 	}
@@ -208,6 +293,9 @@
 	ptr = &elements[0];
 
 	for (element=l->head; element; element=element->next) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(element)
+#endif
 		*ptr++ = element;
 	}
 
@@ -230,7 +318,13 @@
 {
 	zend_llist_element *element;
 
+#if HARDENING_PATCH_LL_PROTECT
+	CHECK_LIST_CANARY(l)
+#endif
 	for (element=l->head; element; element=element->next) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(element)
+#endif
 		func(element->data, arg TSRMLS_CC);
 	}
 }
@@ -241,8 +335,14 @@
 	zend_llist_element *element;
 	va_list args;
 
+#if HARDENING_PATCH_LL_PROTECT
+	CHECK_LIST_CANARY(l)
+#endif
 	va_start(args, num_args);
 	for (element=l->head; element; element=element->next) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(element)
+#endif
 		func(element->data, num_args, args TSRMLS_CC);
 	}
 	va_end(args);
@@ -251,6 +351,10 @@
 
 ZEND_API int zend_llist_count(zend_llist *l)
 {
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();
+	CHECK_LIST_CANARY(l)
+#endif
 	return l->count;
 }
 
@@ -259,8 +363,15 @@
 {
 	zend_llist_position *current = pos ? pos : &l->traverse_ptr;
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();
+	CHECK_LIST_CANARY(l)
+#endif
 	*current = l->head;
 	if (*current) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(*current)
+#endif
 		return (*current)->data;
 	} else {
 		return NULL;
@@ -272,8 +383,15 @@
 {
 	zend_llist_position *current = pos ? pos : &l->traverse_ptr;
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();
+	CHECK_LIST_CANARY(l)
+#endif
 	*current = l->tail;
 	if (*current) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(*current)
+#endif
 		return (*current)->data;
 	} else {
 		return NULL;
@@ -285,9 +403,19 @@
 {
 	zend_llist_position *current = pos ? pos : &l->traverse_ptr;
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();
+	CHECK_LIST_CANARY(l)
+#endif
 	if (*current) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(*current)
+#endif
 		*current = (*current)->next;
 		if (*current) {
+#if HARDENING_PATCH_LL_PROTECT
+			CHECK_LISTELEMENT_CANARY(*current)
+#endif
 			return (*current)->data;
 		}
 	}
@@ -299,9 +427,19 @@
 {
 	zend_llist_position *current = pos ? pos : &l->traverse_ptr;
 
+#if HARDENING_PATCH_LL_PROTECT
+	TSRMLS_FETCH();
+	CHECK_LIST_CANARY(l)
+#endif
 	if (*current) {
+#if HARDENING_PATCH_LL_PROTECT
+		CHECK_LISTELEMENT_CANARY(*current)
+#endif
 		*current = (*current)->prev;
 		if (*current) {
+#if HARDENING_PATCH_LL_PROTECT
+			CHECK_LISTELEMENT_CANARY(*current)
+#endif
 			return (*current)->data;
 		}
 	}
diff -Nura php-5.0.4/Zend/zend_llist.h hardening-patch-5.0.4-0.4.1/Zend/zend_llist.h
--- php-5.0.4/Zend/zend_llist.h	2004-01-08 18:31:47.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_llist.h	2005-08-04 12:06:45.000000000 +0200
@@ -23,6 +23,9 @@
 #define ZEND_LLIST_H
 
 typedef struct _zend_llist_element {
+#if HARDENING_PATCH_LL_PROTECT
+	unsigned int canary;
+#endif	
 	struct _zend_llist_element *next;
 	struct _zend_llist_element *prev;
 	char data[1]; /* Needs to always be last in the struct */
@@ -35,6 +38,9 @@
 typedef void (*llist_apply_func_t)(void * TSRMLS_DC);
 
 typedef struct _zend_llist {
+#if HARDENING_PATCH_LL_PROTECT
+	unsigned int canary_h; /* head */
+#endif	
 	zend_llist_element *head;
 	zend_llist_element *tail;
 	size_t count;
@@ -42,6 +48,9 @@
 	llist_dtor_func_t dtor;
 	unsigned char persistent;
 	zend_llist_element *traverse_ptr;
+#if HARDENING_PATCH_LL_PROTECT
+	unsigned int canary_t; /* tail */
+#endif	
 } zend_llist;
 
 typedef zend_llist_element* zend_llist_position;
diff -Nura php-5.0.4/Zend/zend_modules.h hardening-patch-5.0.4-0.4.1/Zend/zend_modules.h
--- php-5.0.4/Zend/zend_modules.h	2005-03-16 00:47:12.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_modules.h	2005-08-06 18:16:27.582341752 +0200
@@ -38,6 +38,7 @@
 extern struct _zend_arg_info fourth_arg_force_ref[5];
 extern struct _zend_arg_info all_args_by_ref[1];
 
+#define HARDENING_PATCH_ZEND_MODULE_API_NO 1002050805
 #define ZEND_MODULE_API_NO 20041030
 #ifdef ZTS
 #define USING_ZTS 1
@@ -45,10 +46,10 @@
 #define USING_ZTS 0
 #endif
 
-#define STANDARD_MODULE_HEADER sizeof(zend_module_entry), ZEND_MODULE_API_NO, ZEND_DEBUG, USING_ZTS, NULL
-#define ZE2_STANDARD_MODULE_HEADER sizeof(zend_module_entry), ZEND_MODULE_API_NO, ZEND_DEBUG, USING_ZTS, ini_entries
+#define STANDARD_MODULE_HEADER sizeof(zend_module_entry), HARDENING_PATCH_ZEND_MODULE_API_NO, ZEND_DEBUG, USING_ZTS, NULL
+#define ZE2_STANDARD_MODULE_HEADER sizeof(zend_module_entry), HARDENING_PATCH_ZEND_MODULE_API_NO, ZEND_DEBUG, USING_ZTS, ini_entries
 
-#define STANDARD_MODULE_PROPERTIES_EX 0, 0, 0, NULL, 0
+#define STANDARD_MODULE_PROPERTIES_EX 0, 0, 0, NULL, 0, ZEND_MODULE_API_NO
 
 #define STANDARD_MODULE_PROPERTIES \
 	NULL, STANDARD_MODULE_PROPERTIES_EX
@@ -81,6 +82,7 @@
 	unsigned char type;
 	void *handle;
 	int module_number;
+	unsigned int real_zend_api;
 };
 
 
diff -Nura php-5.0.4/Zend/zend_opcode.c hardening-patch-5.0.4-0.4.1/Zend/zend_opcode.c
--- php-5.0.4/Zend/zend_opcode.c	2004-06-06 10:37:12.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/Zend/zend_opcode.c	2005-08-06 10:08:19.000000000 +0200
@@ -92,6 +92,9 @@
 	op_array->uses_this = 0;
 
 	op_array->start_op = NULL;
+#if HARDENING_PATCH
+	op_array->created_by_eval = 0;
+#endif
 
 	zend_llist_apply_with_argument(&zend_extensions, (llist_apply_with_arg_func_t) zend_extension_op_array_ctor_handler, op_array TSRMLS_CC);
 }
